;-------------------------------------------------------------------------------
.586
.mmx
.model flat,STDCALL
;-------------------------------------------------------------------------------
.data
;-------------------------------------------------------------------------------
include motore.inc
include dati.inc
include posizioni.inc
include debug.inc
;-------------------------------------------------------------------------------
delta equ N
;-------------------------------------------------------------------------------
; http://www.asdf.org/~fatphil/x86/pentopt/30.html
;-------------------------------------------------------------------------------
ITER     EQU    10              ; number of iterations
OVERHEAD EQU    69              ; per calcolare l'overhead porlo a 0 (zero)

;-------------------------------------------------------------------------------
.data                           ; data segment
;-------------------------------------------------------------------------------
align   16
counter DD      0
ticsl   DD      0
ticsh   DD      0
tsuml   DD      0
tsumh   DD      0
COUNTER001 DD 100
;-------------------------------------------------------------------------------
.code
;-------------------------------------------------------------------------------

BreakPoint proc
  PRINT sErrore
	ret
endp
;-------------------------------------------------------------------------------
TestMossaOk proc
	; edx = mossa
  pushf
  pushad
	; PUTCHAR '_'
  ; call DebugMossa
  TESTPOINTER edx, mosse, fine_mosse, tmo_esci
  mov eax, [edx.mPezzo]
  TESTPOINTER eax, inizio_pezzi, fine_pezzi, tmo_esci
  mov eax, [eax.pCasa]
  TESTPOINTER eax, scacchiera, badboard, tmo_esci
  TESTNOEQ [eax], ILLEG,tmo_esci
	if DEBUG_CASASRC
	  mov eax, [edx.mSrc]
  	TESTPOINTER eax, scacchiera, badboard, tmo_esci
	  TESTNOEQ [eax], ILLEG,tmo_esci
    add eax, [edx.mDelta]
  	TESTPOINTER eax, scacchiera, badboard, tmo_esci
	  TESTNOEQ [eax], ILLEG,tmo_esci
  endif
tmo_esci:
  popad
  popf
	ret
endp
;-------------------------------------------------------------------------------
TestMosseOk proc
  pushf
	pushad
  mov edx, [esi.nMosse]
tmo_loop:
  cmp edx, [esi.nMosse+size Nodo]
  jge tmo_fine
  call TestMossaOk
  lea edx, [edx+size Mossa]
  jmp tmo_loop
tmo_fine:
  popad
  popf
	ret
endp
;-------------------------------------------------------------------------------
TestSiglaPezzo proc
  pushf
  push eax
  shr eax, 16
  and eax, 0ffh
  je db_ok

  cmp eax,' '
  je db_ok
  cmp eax,'p'
  je db_ok
  cmp eax,'P'
  je db_ok
  cmp eax,'n'
  je db_ok
  cmp eax,'N'
  je db_ok
  cmp eax,'b'
  je db_ok
  cmp eax,'B'
  je db_ok
  cmp eax,'r'
  je db_ok
  cmp eax,'R'
  je db_ok
  cmp eax,'q'
  je db_ok
  cmp eax,'Q'
  je db_ok
  cmp eax,'k'
  je db_ok
  cmp eax,'K'
  je db_ok
  PUTCHAR '$'
  nop
db_ok:
	pop eax
  popf
  ret
endp
;-------------------------------------------------------------------------------
TestRoutine proc
	pushad
  push eax
  xor eax, eax
  mov tsuml, eax
  mov tsumh, eax
  mov COUNTER, ITER
  pop eax
tr_loop:
  pushad
  rdtsc
  mov ticsl, eax
  mov ticsh, edx
  popad
	cld																		; non-pairable filler
  REPT 8
      nop                               ; eight NOP's to avoid shadowing effect
  ENDM

;---------------------------------------
pushad
;--------------------------------------- Put instructions to test here
if OVERHEAD eq 0
		; nessuna istruzione per calcolare il valore di OVERHEAD
else
	call GeneraMosse
endif
;--------------------------------------- End of instructions to test
popad
;---------------------------------------
		cld																	; non-pairable filler with shadow
  pushad
        rdtsc				                   	; read counter again
        sub eax, ticsl
        sbb edx, ticsh
        sub eax, OVERHEAD
        sbb edx, 0
        add tsuml, eax
        add tsumh, edx
        dec COUNTER
  popad
  			jne tr_loop
;---------------------------------------
tr_outloop:
  ACAPO
	mov eax, tsuml
  mov edx, tsumh
  mov ebx, ITER
  div ebx
	call DebugHex
  ACAPO
  popad
  ret
endp
end


