//---------------------------------------------------------------------------
#pragma hdrstop
#pragma argsused
//---------------------------------------------------------------------------
#include <stdio.h>
#include <time.h>
#include <sys\timeb.h>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <process.h>
//---------------------------------------------------------------------------
int AlfaBeta(int alfa, int beta, int livello);
//---------------------------------------------------------------------------
unsigned long _beginthread(void (_USERENTRY *__start)(void *), unsigned __stksize, void *__arg);
//---------------------------------------------------------------------------
#include "motore_cpp.h"
//---------------------------------------------------------------------------
void SalvaFEN()
{
  static int n = 0;
  ++n;
  if(FILE *f=fopen("freccia_fen.txt","a+t"))
  {
		fprintf(f, "%d\t%s\n", n, ret_vals.rPosizioneAtt);
    fclose(f);
  }
}
//---------------------------------------------------------------------------
int SysElapsed()
{
  ftime(&ret_vals.rTimeFine);

  int ms = (ret_vals.rTimeFine.time    - ret_vals.rTimeInizio.time)*1000
         + (ret_vals.rTimeFine.millitm - ret_vals.rTimeInizio.millitm);
  if(ms<1) ms = 1.0;
  return ms;
}

void DebugTime()
{
  printf("\n_________________________\n");
  printf("giocate = %ld\n", ret_vals.rMosseGiocate);
  printf("\nms disponibili = %ld\n", ret_vals.rFullTime);
  printf("ms mossa = %ld\n", ret_vals.rMaxTime);
}
//---------------------------------------------------------------------------
int Elabora(int perft)
{
  #define MINIMO -1000
  #define MASSIMO 1000
  int alfa=MINIMO, beta=MASSIMO, livello=6;
	//AlfaBeta(alfa, beta, livello);
  //----------------------------------
  ftime(&ret_vals.rTimeInizio);

  if(perft)
  {
	  ret_vals.rLivello = perft;
    perfect();
  }else
  {
  	ret_vals.rStop = 0;

    if(ret_vals.rFullTime)
    {
      int mossemancanti = 20 - ret_vals.rMosseGiocate;
      if(mossemancanti<4) mossemancanti = 4;
      // TODO prevedere incremento in s!!!!
			ret_vals.rMaxTime = (ret_vals.rFullTime+ret_vals.rMosseGiocate*1500) / mossemancanti;
    }else
    {
			//ret_vals.rMaxTime;
    }

    //ret_vals.rMaxTime = 0;
	  ret_vals.rLivello = 30;

		DebugTime();

    alfagemma();
  }

  __asm emms;

  #define TO64(N) (abs(double(N##H)* double(0x10000)* double(0x10000)) + abs(double(N##L)))
  //----------------------------------
  int millis				 = SysElapsed();

  if(ret_vals.rFullTime)
  {
  	ret_vals.rFullTime -= millis;
    if(ret_vals.rFullTime<1000) ret_vals.rFullTime = 1000;
  }

  double ms = millis;

  double numnodi     = TO64(ret_vals.rNumNodi);
  double nummosse    = TO64(ret_vals.rNumMosse);
  double nummosseliv = TO64(nodi[ret_vals.rLivello-1].nNumMosse);
  double numTT       = TO64(ret_vals.rNumTT);
  double valore      = double(ret_vals.rValore)/double(ret_vals.rValPedone);
  double basenodi    = log(numnodi+1)/log(ret_vals.rLivello+2);
  double clock       = -(double(ret_vals.rClockH)* double(0x10000)* double(0x10000)+double(ret_vals.rClockL));
  clock /= 1000000000.0;
  printf("\n\n%ld:", ret_vals.rLivello);
  if(perft)
  {
	  printf(" perft=%0.0lf", nummosseliv);
  }

  printf(" ms=%0.0lf", ms);
  //printf(" val=%lf", valore);
  printf(" nodi=%0.0lf", numnodi);
  //printf(" clock %lf",clock);
  printf(" n/s=%0.0lf", 1000.0 * numnodi / ms);
  printf(" mosse=%0.0lf", nummosse);
  printf(" m/s=%0.0lf", (nummosse ? 1000.0 * nummosse / ms : 0.0));
  printf(" tt=%0.0lf%%\n", (nummosse ? numTT/nummosse*100.0 : 0.0));
  printf(" time=%ld\n", ret_vals.rFullTime);

  SalvaFEN();

  return true;
}
//---------------------------------------------------------------------------
int Comando()
{
  printf("\n--- www.linformatica.com --- Freccia 0.0.2 - ? help\n"
         ">"
         );
	return toupper(getch());
}
//---------------------------------------------------------------------------
bool Ask(const char *messaggio)
{
	printf("%s (Y/N)", messaggio);
  int c = toupper(getch());
  return c=='Y';
}
//---------------------------------------------------------------------------
#if 1
int main(int argc, char* argv[])
{

	printf("\nFreccia 0.0.2.5 - 12/11/2011\n");
  char posizione[512];
  //strcpy(posizione, "8/7k/2n4P/1P6/8/8/8/7K b - - 0 1");
  strcpy(posizione, "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1");
  char posizioneatt[512];  strcpy(posizioneatt, posizione);

  const int mega = 0x100000;
  const int ttsize = 128 * mega;

  ret_vals.rLivello = 32;
  ret_vals.rTTable = (int) new char *[ttsize];
  ret_vals.rTTableSize = ttsize;
  ret_vals.rFlags = 1;
  ret_vals.rPosizione = posizione;
  ret_vals.rPosizioneAtt = posizioneatt;
  ret_vals.rMosseGiocate = 0;
	//ret_vals.rMaxTime = 3600 * 1000;  // un'ora

	inizializza_alfagemma();
  cleartt();
	*ret_vals.rPosizione = 0;

  for(bool bFinito = false; !bFinito; )
  {
    char mossa[512];
    printf(">");
    fgets(mossa, 10, stdin);
    ret_vals.rMossa = mossa;
    if(mossa[1]!='\n')
    {
    	esegui();
		  SalvaFEN();
    } else switch(int c = toupper(mossa[0]))
    {
			case 'S': show();																				break;
    	case 'T': Elabora(0);																		break;
    	case 'P': { char depth[512];
                  int idepth = 4;
                  printf(" Insert depth: ");
      						fgets(depth, 510, stdin);
                  sscanf(depth, "%ld", &idepth);
                  Elabora(idepth);
                 }                                            break;
    	case 'X': bFinito = Ask("Do you want to exit?");				break;
    	case 'F': {
                  printf("\nInsert FEN string: ");
      						fgets(posizione, 510, stdin);
                  if(posizione[0]!='\n' && posizione[0]!='\r')
                  {
                    ret_vals.rMosseGiocate = 0;
                    inizializza_alfagemma();
                    cleartt();
                    *ret_vals.rPosizione = 0;
                  }
								  SalvaFEN();
      					}																							break;
    	case 'M': {
                  char seconds[512];
                  int secondi = 0;
                  printf(" Insert seconds/move: ");
      						fgets(seconds, 510, stdin);
                  sscanf(seconds, "%ld", &secondi);
                  ret_vals.rFullTime = 0;
									ret_vals.rMaxTime = secondi * 1000;
      					}																							break;
    	case 'G': {
                  char seconds[512];
                  int secondi = 0;
                  printf(" Insert seconds/game: ");
      						fgets(seconds, 510, stdin);
                  sscanf(seconds, "%ld", &secondi);
									ret_vals.rFullTime = secondi * 1000;
									ret_vals.rMaxTime = 0;
      					}																							break;
    	//case  27: bFinito = true;																break;
      case  '?':
      						printf("\n"
                  			 " ?: help\n"
                  			 " S: Show chessboard\n"
                  			 " T: Think\n"
                  			 " P: Perfect level\n"
                         " X: Exit\n"
                         " F: set from FEN\n"
                         " M: time in seconds/Move\n"
                         " G: time in seconds/Game\n"
                         " e2e4: move\n"
                         " e1g1: castling\n"
                         " e7e8Q: promotion\n"
                  );     																			break;
    }
  }
  printf("\n\n");
	return 0;
}
#else
int main(int argc, char* argv[])
{

	printf("\nFreccia 0.0.2.50 - 12/11/2011\n");
  char posizione[512];
  //strcpy(posizione, "8/7k/2n4P/1P6/8/8/8/7K b - - 0 1");
  strcpy(posizione, "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1");
  char posizioneatt[512];  strcpy(posizioneatt, posizione);

  const int mega = 0x100000;
  const int ttsize = 128 * mega;

  ret_vals.rLivello = 32;
  ret_vals.rTTable = (int) new char *[ttsize];
  ret_vals.rTTableSize = ttsize;
  ret_vals.rFlags = 1;
  ret_vals.rPosizione = posizione;
  ret_vals.rPosizioneAtt = posizioneatt;
  ret_vals.rMosseGiocate = 0;

	inizializza_alfagemma();
  cleartt();
	*ret_vals.rPosizione = 0;

  for(bool bFinito = false; !bFinito; )
  {
    switch(int c = Comando())
    {
			case '?': show();																				break;
    	case 'T': Elabora(0); 																	break;
    	case 'P': { char depth[512];
                  int idepth = 4;
                  printf(" Insert depth: ");
      						fgets(depth, 510, stdin);
                  sscanf(depth, "%ld", &idepth);
                  Elabora(depth);
                 }                                            break;
    	case 'X': bFinito = Ask("Do you want to exit?");				break;
    	case 'N': {
                  printf("\nInsert FEN string: ");
      						fgets(posizione, 510, stdin);
                  if(posizione[0]!='\n' && posizione[0]!='\r')
                  {
                    ret_vals.rMosseGiocate = 0;
                    inizializza_alfagemma();
                    cleartt();
                    *ret_vals.rPosizione = 0;
                  }
      					}																							break;
    	case 'V': {
                  char seconds[512];
                  int secondi = 0;
                  printf(" Insert seconds/move: ");
      						fgets(seconds, 510, stdin);
                  sscanf(seconds, "%ld", &secondi);
                  ret_vals.rFullTime = 0;
									ret_vals.rMaxTime = secondi * 1000;
      					}																							break;
    	case 'M': {
                  char seconds[512];
                  int secondi = 0;
                  printf(" Insert seconds/game: ");
      						fgets(seconds, 510, stdin);
                  sscanf(seconds, "%ld", &secondi);
									ret_vals.rFullTime = secondi * 1000;
									ret_vals.rMaxTime = 0;
      					}																							break;
    	//case  27: bFinito = true;																break;
      case  '\n':
      case  '\r':
      						printf("\n"
                  			 " ?: Show chessboard\n"
                  			 " T: Think\n"
                  			 " P: Perfect level\n"
                         " X: Exit\n"
                         " N: set from FEN\n"
                         " V: time in seconds/moVe\n"
                         " M: time in seconds/gaMe\n"
                         "  : [space] to enter your move ( e2e4)\n"
                  );     																			break;
    	case 'A':
    	case 'B':
    	case 'C':
    	case 'D':
    	case 'E':
    	case 'F':
    	case 'G':
    	case 'H':
      					{
                  char mossa[512];
                  mossa[0] = tolower(c);
                  mossa[1] = '\n';
                  mossa[2] = 0;
                  printf("%c", tolower(c));
      						fgets(mossa+1, 9, stdin);
									ret_vals.rMossa = mossa;
                  if(mossa[1]!='\n') esegui();
						                 else printf("(aborted)\n");
      					}																							break;
    }
  }
  printf("\n\n");
	return 0;
}
#endif
//---------------------------------------------------------------------------
int SysGetChar()
{
	return getchar();
}
//---------------------------------------------------------------------------
void SysChar(int c)
{
	putchar(c);
}
//---------------------------------------------------------------------------
void SysPrintf(const char *s)
{
	printf(s);
}
//---------------------------------------------------------------------------
int GenerateMoves()
{
	return 0;
}
//---------------------------------------------------------------------------
int NextMove()
{
  static int m=10;
	return m--;
}
//---------------------------------------------------------------------------
int Valuta()
{
	return 0;
}
//---------------------------------------------------------------------------
#if 0
int AlfaBeta(int alfa, int beta, int livello)
{
   GenerateMoves();
   if(livello == 0) return Valuta(); // quiesce( alpha, beta );
   while(NextMove())
   {
      int score = -AlfaBeta( -beta, -alfa, livello - 1 );
      if(score >= beta)
      {
         return beta;   // beta cutoff
      }
      if(score>alfa)
      {
         alfa = score; // alfa acts like max in MiniMax
      }
   }
   return alfa;
}
//---------------------------------------------------------------------------
 alfa		 beta			MINIMO	MASSIMO
-beta		-alfa
 alfa		 beta
-beta		-alfa
 alfa		 beta

int score = -AlfaBeta( -beta, -alfa, livello - 1 );

MINIMO   ( )
MASSIMO  (x)
MINIMO   ( )
MASSIMO  (x)
MINIMO   ( )
MASSIMO  (x)
#endif
