;-------------------------------------------------------------------------------
.686
.mmx
.model flat, STDCALL
;-------------------------------------------------------------------------------
.data
include motore.inc
include dati.inc
include posizioni.inc
include debug.inc
;-------------------------------------------------------------------------------
.code
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;                                                                   MACRO COMUNI
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------

PUSHM macro delta, speciale
	local pm_nomossadbg
  ; eax: flags colore
  ; edi: mossa
  ; ecx: pezzo
  ; edx: casa
  ; -> edi+=size Mossa
  ; -> ebx: valore della mossa
  ; NB [001]: NON DEVE CAMBIARE I FLAGS!!!
	if 1
    mov ebx, [edx+delta]                  ; cFlags
    mov [edi.mDelta], delta								; spostamento
    mov [edi.mPezzo], ecx    							; pezzo mosso
    mov [edi.mValore], ebx   							; valore mossa (pezzo preso/casa vuota)
    if DEBUG_ASSERT
      pushf
      push eax
		  TESTPOINTER edi, mosse, fine_mosse
	    inc _ret_vals.rNumMossa
      mov eax, _ret_vals.rNumMossa
	    mov [edi.mNumMossa], eax
      cmp eax, 0ffffffffh               ; mettere mNumMossa da debuggare
      jne pm_nomossadbg
      call BreakPoint
    pm_nomossadbg:
      pop eax
      popf
    endif
  else
  	movq mm0, qword ptr [edx+delta]      	; carica valore/flags + pezzo preso
    mov [edi.mPezzo], ecx    							; pezzo mosso
    mov [edi.mDelta], delta								; spostamento
    movq qword ptr [edi.mValore], mm0			; salva il valore/flags + pezzo preso
  endif
  ifb <speciale>
    if 0
		  movq qword ptr [edi.mSpeciale], mm7 ; azzera flags speciale+promozione
    else
		  mov dword ptr [edi.mSpeciale], 0  ; azzera flags speciale+promozione
    endif
  else
	  mov DWORD PTR [edi.mSpeciale], \
                         speciale       ; assegna flags speciale
  endif
  if DEBUG_CASASRC
	  mov [edi.mSrc], edx   							; casa sorgente
  endif

  if DEBUG_GENERATORE
    push edx
    mov edx, edi
    call TestMossaOk
    pop edx
  endif
  lea edi, [edi+size Mossa]             ; punta alla prossima mossa
endm
;-------------------------------------------------------------------------------
; push promozione
;-------------------------------------------------------------------------------
TEST_PROMO macro delta
	local @tpr_fine, @tpr_promoB, @tpr_promoN
  lea ebx, [edx+delta]
  cmp ebx, offset promoB
  jl @tpr_promoB
  cmp ebx, offset promoN
  jl @tpr_fine
@tpr_promoN:
  mov [edi.mSpeciale-size Mossa], F_DONNA_NERA
	PUSHM delta, F_TORRE_NERA
	PUSHM delta, F_ALFIERE_NERO
	PUSHM delta, F_CAVALLO_NERO
  jmp @tpr_fine
@tpr_promoB:
  mov [edi.mSpeciale-size Mossa], F_DONNA_BIANCA
	PUSHM delta, F_TORRE_BIANCA
	PUSHM delta, F_ALFIERE_BIANCO
	PUSHM delta, F_CAVALLO_BIANCO
@tpr_fine:
endm
;-------------------------------------------------------------------------------
; solo prese                                                      PRESE (PEDONE)
;-------------------------------------------------------------------------------
TESTP macro delta, tpromo
	local @tp_nopresa
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	; and bit colore      z: preso pezzo ---\___legale
	;                     s: vuota       ---/
	;                     g: illegale
	test eax, [edx+delta]
	jnz @tp_nopresa        								; non  una presa
	PUSHM delta 													; pezzo preso
  ifnb <tpromo>
		TEST_PROMO delta										; salva le eventuali promozioni a DTAC
  endif
@tp_nopresa:
endm
;-------------------------------------------------------------------------------
; non prese                                                   NON PRESE (PEDONE)
;-------------------------------------------------------------------------------
TESTNP macro delta, finedir, tpromo_didue
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	; and bit colore      z: preso pezzo ---\___legale
	;                     s: vuota       ---/
	;                     g: illegale
	test eax, [edx+delta]
	jns finedir            								; mossa illegale (fuori scacchiera o pezzo stesso colore)

  ifb <tpromo_didue>
		PUSHM delta 												; casa vuota o pezzo preso
  else
    ifidn <tpromo_didue>, <1>
      PUSHM delta												; casa vuota o pezzo preso
      TEST_PROMO delta									; salva le eventuali promozioni a DTAC
    endif

    ifidn <tpromo_didue>, <2>
      PUSHM delta, F_SPINTADIDUE				; casa vuota o pezzo preso
    endif
  endif

endm
;-------------------------------------------------------------------------------
; mosse di Re e Cavallo                                       MOSSE RE E CAVALLO
;-------------------------------------------------------------------------------
TESTM_NODIR macro delta
	local @tmn_fine
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	test eax, [edx+delta]
	jg @tmn_fine
	PUSHM delta
@tmn_fine:
endm
;-------------------------------------------------------------------------------
; mosse di Alfiere/Torre/Donna                         MOSSE ALFIERE/TORRE/DONNA
;-------------------------------------------------------------------------------

TESTM macro delta, finedir
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	; and bit colore      z: preso pezzo ---\___legale
	;                     s: vuota       ---/
	;                     g: illegale
	test eax, [edx+delta]
	jg finedir	          								; mossa illegale (fuori scacchiera o pezzo stesso colore)
	PUSHM delta 													; casa vuota o pezzo preso
	jns finedir         								  ; fine direzione per pezzo preso [001]
endm
;-------------------------------------------------------------------------------
TEST_NP2 macro delta
	local @m_finedir2
	;------------------------------------------
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	;------------------------------------------
	TESTNP delta*1, @m_finedir2
	TESTNP delta*2, @m_finedir2, 2
@m_finedir2:
endm
;-------------------------------------------------------------------------------
TEST_DIR macro delta
  local @m_finedir
  ;------------------------------------------
  ; eax: flags colore
  ; ecx: pezzo
  ; edx: casa
  ;------------------------------------------
  TESTM delta*1,@m_finedir
  TESTM delta*2,@m_finedir
  TESTM delta*3,@m_finedir
  TESTM delta*4,@m_finedir
  TESTM delta*5,@m_finedir
  TESTM delta*6,@m_finedir
  TESTM delta*7,@m_finedir
@m_finedir:
endm
;-------------------------------------------------------------------------------
TEST_DIR4 macro delta1,delta2,delta3,delta4
	TEST_DIR delta1
  TEST_DIR delta2
  TEST_DIR delta3
  TEST_DIR delta4
endm
;-----------------------------------------------------------------------------RE

MuoviRe proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TESTM_NODIR N
  TESTM_NODIR S
  TESTM_NODIR W
  TESTM_NODIR E
	TESTM_NODIR NE
	TESTM_NODIR SE
	TESTM_NODIR NW
	TESTM_NODIR SW
	ret
endp
;--------------------------------------------------------------------------DONNA

MuoviDonna proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TEST_DIR4 N,S,E,W
	TEST_DIR4 NE,SE,NW,SW
	ret
endp
;--------------------------------------------------------------------------TORRE

MuoviTorre proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TEST_DIR4 N,S,E,W
	ret
endp
;------------------------------------------------------------------------ALFIERE

MuoviAlfiere proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TEST_DIR4 NE,SE,NW,SW
	ret
endp
;------------------------------------------------------------------------CAVALLO

MuoviCavallo proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TESTM_NODIR NNE
  TESTM_NODIR NNW
  TESTM_NODIR NEE
  TESTM_NODIR NWW
	TESTM_NODIR SSE
	TESTM_NODIR SSW
	TESTM_NODIR SEE
	TESTM_NODIR SWW
	ret
endp
;------------------------------------------------------------------------PEDONEB

MuoviPedoneB proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
  ;nop
	TESTP NE, test_promo
	TESTP NW, test_promo
  cmp edx, offset m2pedoneB
  jl mpb_no2
  TEST_NP2 N
  ret
mpb_no2:
	TESTNP N, mpb_ret, 1
mpb_ret:
	ret
endp
;------------------------------------------------------------------------PEDONEN

MuoviPedoneN proc
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	TESTP SE, test_promo
	TESTP SW, test_promo
  cmp edx, offset m2pedoneN
  jge mpn_no2
  TEST_NP2 S
  ret
mpn_no2:
	TESTNP S, mpn_ret, 1
mpn_ret:
	ret
endp
;-------------------------------------------------------------------------------
;                                   ___
; and bit colore      z: preso pezzo   \___legale
;                     s: vuota      ___/
;                     g: illegale
;
TPEZZO macro TS_PEZZO, TS_DELTA, TS_SCACCO
	; eax: flags del colore che muove
  ; edx: posizione del Re
  ; z=1 se c' il pezzo
	test DWORD PTR [edx.cFlags+TS_DELTA], TS_PEZZO
  jne TS_SCACCO													;  scacco
endm
;-------------------------------------------------------------------------------
;                                   ___
; and bit colore      z: preso pezzo   \___legale
;                     s: vuota      ___/
;                     g: illegale
;
TSCACCO1 macro TS_PEZZI, TS_DELTA, TS_SCACCO, TS_FINEDIR
  ; edx: posizione del Re
  test [edx.cFlags+TS_DELTA], TS_PEZZI
	jnp TS_SCACCO
	jge TS_FINEDIR
endm
;-------------------------------------------------------------------------------

TSCACCO7 macro TS_PEZZI1, TS_PEZZI7, TS_DELTA, TS_SCACCO
	local @ts_finedir
	; eax: flags del colore che muove
  ; edx: posizione del Re
  ifdif <TSPEZZI7>,<0>
    TSCACCO1 TS_PEZZI1, TS_DELTA*1, TS_SCACCO, @ts_finedir
	  mov ebx, TS_PEZZI7
    TSCACCO1 ebx, %(TS_DELTA*2), TS_SCACCO, @ts_finedir
    TSCACCO1 ebx, %(TS_DELTA*3), TS_SCACCO, @ts_finedir
    TSCACCO1 ebx, %(TS_DELTA*4), TS_SCACCO, @ts_finedir
    TSCACCO1 ebx, %(TS_DELTA*5), TS_SCACCO, @ts_finedir
    TSCACCO1 ebx, %(TS_DELTA*6), TS_SCACCO, @ts_finedir
    TSCACCO1 ebx, %(TS_DELTA*7), TS_SCACCO, @ts_finedir
  else
    TSCACCO1 TS_PEZZI1, TS_DELTA*1, TS_SCACCO, @ts_finedir
  endif
@ts_finedir:
endm
;-------------------------------------------------------------------------------

TestScacco proc
	; verifica che il RE del nodo corrente non sia sotto scacco
	; esi: nodo
  ; ritorna np se scacco
  if TEST_SCACCO
    push eax
    push ebx
    push edx
    mov ebx, [esi.nRe]									; punta al pezzo RE
    mov eax, [esi.nFlags]               ; bit colore del nodo
    mov edx, [ebx.pCasa]								; casa del RE
    call TestScaccoCasaEdx
    pop edx
    pop ebx
    pop eax
  else
    push eax
    xor eax, eax                        ; p=1
    pop eax
  endif
  ret
endp
;-------------------------------------------------------------------------------
TestScaccoCasaEdx proc
	; verifica che la casa in edx non sia sotto scacco
	; esi: nodo
  ; eax: bit colore del nodo
  ; edx: casa da verificare
  ; ritorna np se scacco (np=flag parit 0)
	push ebx															; viene usato dalle macro TSCACCO
	test DWORD PTR [esi.nFlags], F_BIANCO
  je ts_nero
ts_bianco:
  TSCACCO7 F_COLORI+F_N_PEDONE+F_N_ALFIERE+F_N_RE, F_COLORI+F_N_ALFIERE, NE, ts_sottoscacco
  TSCACCO7 F_COLORI+F_N_PEDONE+F_N_ALFIERE+F_N_RE, F_COLORI+F_N_ALFIERE, NW, ts_sottoscacco
  TSCACCO7 F_COLORI+F_N_ALFIERE+F_N_RE,            F_COLORI+F_N_ALFIERE, SE, ts_sottoscacco
  TSCACCO7 F_COLORI+F_N_ALFIERE+F_N_RE,            F_COLORI+F_N_ALFIERE, SW, ts_sottoscacco

	TSCACCO7 F_COLORI+F_N_TORRE+F_N_RE, F_COLORI+F_N_TORRE, N, ts_sottoscacco
	TSCACCO7 F_COLORI+F_N_TORRE+F_N_RE, F_COLORI+F_N_TORRE, S, ts_sottoscacco
	TSCACCO7 F_COLORI+F_N_TORRE+F_N_RE, F_COLORI+F_N_TORRE, E, ts_sottoscacco
	TSCACCO7 F_COLORI+F_N_TORRE+F_N_RE, F_COLORI+F_N_TORRE, W, ts_sottoscacco

	mov ebx, F_N_CAVALLO
  jmp ts_cavalli

ts_nero:
  TSCACCO7 F_COLORI+F_B_PEDONE+F_B_ALFIERE+F_B_RE, F_COLORI+F_B_ALFIERE, SE, ts_sottoscacco
  TSCACCO7 F_COLORI+F_B_PEDONE+F_B_ALFIERE+F_B_RE, F_COLORI+F_B_ALFIERE, SW, ts_sottoscacco
  TSCACCO7 F_COLORI+F_B_ALFIERE+F_B_RE,            F_COLORI+F_B_ALFIERE, NE, ts_sottoscacco
  TSCACCO7 F_COLORI+F_B_ALFIERE+F_B_RE,            F_COLORI+F_B_ALFIERE, NW, ts_sottoscacco

	TSCACCO7 F_COLORI+F_B_TORRE+F_B_RE, F_COLORI+F_B_TORRE, N, ts_sottoscacco
	TSCACCO7 F_COLORI+F_B_TORRE+F_B_RE, F_COLORI+F_B_TORRE, S, ts_sottoscacco
	TSCACCO7 F_COLORI+F_B_TORRE+F_B_RE, F_COLORI+F_B_TORRE, E, ts_sottoscacco
	TSCACCO7 F_COLORI+F_B_TORRE+F_B_RE, F_COLORI+F_B_TORRE, W, ts_sottoscacco

	mov ebx, F_B_CAVALLO

ts_cavalli:
  TPEZZO ebx, (N+N+E), ts_sottoscacco2
  TPEZZO ebx, (N+N+W), ts_sottoscacco2
  TPEZZO ebx, (N+E+E), ts_sottoscacco2
  TPEZZO ebx, (N+W+W), ts_sottoscacco2
  TPEZZO ebx, (S+S+E), ts_sottoscacco2
  TPEZZO ebx, (S+S+W), ts_sottoscacco2
  TPEZZO ebx, (S+E+E), ts_sottoscacco2
  TPEZZO ebx, (S+W+W), ts_sottoscacco2

ts_nomatto:
	xor ebx, ebx													; p=1 non  scacco
ts_sottoscacco:
	pop ebx
	ret
ts_sottoscacco2:
	xor ebx, ebx
  inc ebx																; forza p=0 per indicare scacco
	pop ebx
  ret
endp

;-------------------------------------------------------------------------------

; l'enpassant viene salvato come presa laterale di pedone
; EseguiMossa ed AnnullaMossa ne tengono conto
; per eseguire correttamente la presa
EnPassant proc
  push eax
	mov ebx, [esi.nEnPassant-size Nodo]   ; posizione pedone catturabile en-passant
  xor eax, F_BIANCO OR F_NERO
ep_W:
  lea edx, [ebx.cFlags+E]								; carica la casa sorgente
  test [edx.cFlags], eax					    	; verifica se c' un pezzo dello stesso colore (eax sono i flags invertiti)
	jnz ep_E                                 ; TODO: usare jp per test colore+tipo
  test [edx.cFlags], F_N_PEDONE+F_B_PEDONE ; verifica se si tratta di un pedone
	jz ep_E
	mov ecx, [edx.cPezzo]									; carica il pedone
  push ebx
  PUSHM W, F_ENPASSANT
  pop ebx
ep_E:
  lea edx, [ebx.cFlags+W]								; carica la casa sorgente
  test [edx.cFlags], eax					    	; verifica se c' un pezzo dello stesso colore (eax sono i flags invertiti)
	jnz ep_ret                               ; TODO: usare jp per test colore+tipo
  test [edx.cFlags], F_N_PEDONE+F_B_PEDONE ; verifica se si tratta di un pedone
	jz ep_ret
	mov ecx, [edx.cPezzo]									; carica il pedone
  push ebx
  PUSHM E, F_ENPASSANT
  pop ebx
ep_ret:
	pop eax
	ret
endp
;-------------------------------------------------------------------------------

TestArrocchi proc
ta_test_re_mosso:
  mov ecx, [esi.nRe]
  cmp [ecx.pNumMosse], 0
  jne ta_noarrocco
  call TestScacco												; il Re non deve essere sotto scacco
  jnp ta_noarrocco
	;------------------------- arrocco 00
ta_test_00:
  mov edx, [ecx.pCasa]									; edx = casa del Re
  test [edx.cFlags+E], F_VUOTA					; le case devono essere vuote
  je ta_test_000
  test [edx.cFlags+EE], F_VUOTA					; le case devono essere vuote
  je ta_test_000
ta_test_torre_mossa_00:
  mov ebx, [edx.cPezzo+EEE]							; torre coinvolta nell'arrocco
  test ebx, ebx
  je ta_test_000
	cmp [ebx.pNumMosse], 0								; NB: solo la torre originale pu avere pNumMosse=0, ogni altro pezzo deve essere stato mosso l
  jne ta_test_000
ta_test_scacco_E:
  lea edx, [edx+E]
  call TestScaccoCasaEdx								; la prima casa dell'arrocco corto non deve essere sotto scacco
  jnp ta_test_000
ta_arrocco_00:
  mov edx, [ecx.pCasa]									; edx = casa del Re
	PUSHM EE, F_ARROCCO_00
	;------------------------- arrocco 000
ta_test_000:
  mov edx, [ecx.pCasa]									; edx = casa del Re
  test [edx.cFlags+W], F_VUOTA					; le case devono essere vuote
  je ta_noarrocco
  test [edx.cFlags+WW], F_VUOTA					; le case devono essere vuote
  je ta_noarrocco
  test [edx.cFlags+WWW], F_VUOTA				; le case devono essere vuote
  je ta_noarrocco
ta_test_torre_mossa_000:
  mov ebx, [edx.cPezzo+WWWW]						; torre coinvolta nell'arrocco
  test ebx, ebx
  je ta_noarrocco
	cmp [ebx.pNumMosse], 0								; NB: solo la torre originale pu avere pNumMosse=0, ogni altro pezzo deve essere stato mosso l
  jne ta_noarrocco
ta_test_scacco_W:
  lea edx, [edx+W]
  call TestScaccoCasaEdx								; la prima casa dell'arrocco corto non deve essere sotto scacco
  jnp ta_noarrocco
ta_arrocco_000:
  mov edx, [ecx.pCasa]									; edx = casa del Re
	PUSHM WW, F_ARROCCO_000
ta_noarrocco:
	ret
endp
;-------------------------------------------------------------------------------

GeneraMosse proc
	; genera le mosse del colore del nodo esi
	; esi: nodo
	if DEBUG
	  ACAPO
  	PUTCHARS 'G',':'
  endif
  movq qword ptr [esi.nNumValideL], mm7 ; azzera le mosse valide del nodo
	mov eax, [esi.nFlags]      						; flags colore del nodo
	mov edi, [esi.nMosse]      						; prima mossa del nodo
	;------------------------- en passant
  cmp [esi.nEnPassant-size Nodo], 0
  je gm_noenp
	call EnPassant			      						; routine di generazione prese en-passant
gm_noenp:
	;-------------------------
	mov ecx, [esi.nPezzi]      						; punta al primo dei pezzi del colore del nodo
	jmp gm_start
gm_ciclopezzi:
	cmp [edx.cPezzo], ecx      						; si chiede se il pezzo  stato catturato
	jne gm_pezzopreso
	; eax: flags colore
	; ecx: pezzo
	; edx: casa
	; edi: mossa
	; esi: nodo
	call [ecx.pMuovi]					 						; routine di generazione mosse del pezzo
gm_pezzopreso:
	lea ecx, [ecx+size Pezzo]
gm_start:
	mov edx, [ecx.pCasa]       						; casa in cui si trova il pezzo
	test edx, edx              						; se  zero => e' l'ultimo pezzo
	jne gm_ciclopezzi
gm_fine:
	;------------------------- arrocchi
  call TestArrocchi
	;-------------------------
	mov [esi.nMosse+size Nodo], edi				; prima mossa del nodo seguente

	mov ebx, ebp
  if DEBUG_MOSSE
    call DebugMosse
  endif
  if CONTA_MOSSE
  	push eax
    mov eax, edi
    sub eax, [esi.nMosse]
    shr eax, SIZEMOSSA2
    add [esi.nNumMosseL], eax
    adc [esi.nNumMosseH], 0
    pop eax
  endif
	if DEBUG_ALFAGEMMA
		call DebugMosse
  endif
  TESTMOSSE

  ret
endp
;-------------------------------------------------------------------------------
CercaMigliore proc
	; esi: nodo
	; -> edx: migliore mossa; z=1 se finite
	mov edi, [esi.nMosse]
	mov ecx, [esi.nMosse+size Nodo] 			; prima mossa del nodo seguente
	mov ebx, MINIMO
	xor edx, edx                          ; punta alla miglior mossa trovata fino ad ora
cm_ciclo:
	cmp edi, ecx
  mov eax, [edi.mValore]
	je cm_finite
	cmp ebx, eax
	jge cm_nomagg
cm_assegna:
  mov edx, edi
  mov ebx, eax
cm_nomagg:
	lea edi, [edi+size Mossa]
	jmp cm_ciclo
cm_finite:
	test edx, edx
	ret
endp
;-------------------------------------------------------------------------------
UNROLL_COUNT equ 256
;-------------------------------------------------------------------------------
CercaMiglioreFast proc
	; esi: nodo
	; -> edx: migliore mossa; z=1 se finite

	mov edi, [esi.nMosse]                 ; prima mossa del nodo attuale
	mov ecx, [esi.nMosse+size Nodo] 			; prima mossa del nodo seguente

  sub ecx, edi
  je cmf_ret

  rept_size = (offset cmf_finite - offset cmf_ciclo)/UNROLL_COUNT

  ; ecx = cmf_ciclo + (UNROLL_COUNT - ecx / 32) * 16
  ; ecx = cmf_finite - ecx / 32 * 16

  shr ecx, SIZEMOSSA2                   ; numero di mosse
  sub ecx, UNROLL_COUNT
  imul ecx, -rept_size
	add ecx, offset cmf_ciclo             ; si posiziona

	mov ebx, MINIMO
	xor edx, edx                          ; punta alla miglior mossa trovata fino ad ora
  jmp ecx
cmf_ciclo:
	unroll_delta = UNROLL_COUNT * size Mossa
	REPEAT UNROLL_COUNT
  	local ur_jmp
		unroll_delta = unroll_delta - size Mossa
    mov ecx, unroll_delta
    cmp ebx, [edi.mValore + ecx]
    jge ur_jmp
    mov ebx, [edi.mValore + ecx]
    lea edx, [edi + ecx]
   ur_jmp:
	ENDM
cmf_finite:
	cmp ebx, MINIMO                       ; z=1 se le mosse sono state tutte giocate
cmf_ret:
	ret
endp
;-------------------------------------------------------------------------------
_esegui proc
	pushad
  mov esi, offset Nodi
  mov eax, _ret_vals.rLivello
  mov _ret_vals.rLivello, 1
	call _perfect
  mov _ret_vals.rLivello, eax
  mov edi, _ret_vals.rMossa
  call CercaMossa
  test edx, edx
  je es_fine
  call EseguiMossaColore
  call RicalcolaFEN
es_fine:
  popad
	ret
endp
;-------------------------------------------------------------------------------
EseguiMossaColore proc
	; esegue la mossa in edx
  ; e cambia colore
  ; edx: punta alla mossa da eseguire
  ACAPO
  call EseguiMossa
  PRINT sEseguita
  call DebugMossa
  call DebugCase

  call RicalcolaFEN
  mov eax, _ret_vals.rPosizioneAtt
  PRINT sFEN, eax

 	mov eax, nodoA.nRe
 	xchg eax, nodoB.nRe
 	mov nodoA.nRe, eax

 	mov eax, nodoA.nPezzi
 	xchg eax, nodoB.nPezzi
 	mov nodoA.nPezzi, eax

 	mov eax, nodoA.nFlags
 	xchg eax, nodoB.nFlags
 	mov nodoA.nFlags, eax

 	mov eax, nodoA.nDelta1
 	xchg eax, nodoB.nDelta1
 	mov nodoA.nDelta1, eax

 	mov eax, nodoA.nDelta2
 	xchg eax, nodoB.nDelta2
 	mov nodoA.nDelta2, eax

  mov eax, [nodi.nEnPassant]						; rende possibile l'en passant all'avversario
  mov [nodoB.nEnPassant], eax
  ret
endp
;-------------------------------------------------------------------------------
EseguiMossa proc
	; esi: nodo
	; edx: mossa da eseguire
  if DEBUG_ALFAGEMMA
		mov [esi.nEseguita], 0
  	PRINT sEseguo, [esi.nLivello]
  	call DebugMossa
  endif

  if DEBUG_ASSERT
    call TestMossaOk
  endif
  cmp edx, 0
  je em_esci
em_notick:
	mov ebx, [edx.mPezzo]      						; ebx=pezzo
	mov [esi.nEseguita], edx   						; salva la mossa eseguita
	mov edi, [ebx.pCasa]       						;
  TESTPOINTER edi, scacchiera, badboard

	mov [edx.mValore], MINIMO             ; la segnala come eseguita
	mov ecx, edi													; ecx=casa sorgente
  add edi, [edx.mDelta]      						; edi=casa destinazione
  TESTPOINTER edi, scacchiera, badboard

  movq qword ptr [esi.nEnPassant], mm7	; azzera flags enpassant

	mov [esi.nmSrc], ecx       						; salva la casa sorgente per annullare la mossa
  mov [esi.nmDst], edi       						; salva la casa di destinazione per annullare la mossa
  inc [ebx.pNumMosse]										; numero di mosse eseguite dal pezzo
  TESTPOINTER ecx, scacchiera, badboard
  TESTPOINTER edi, scacchiera, badboard

	movq mm0, [ecx]												; mm0=flags+pezzo mosso
  movq mm1, [edi]												; mm1=flags+pezzo preso (o casa vuota)
  movq [ecx], mm6                       ; pone a "casa vuota" la casa sorgente
  movq [edi], mm0												; sposta il pezzo ed i suoi flags
  movq QWORD PTR [esi.nmFlagsP], mm1		; salva flags+pezzo preso nel nodo

  movd eax, mm1													; eax=valore

  if DEBUG_SIGLA
  	push eax
	  call TestSiglaPezzo
    pop eax
  endif

  sub ebp, [ecx.cValCasa]								; toglie il valore della casa sorgente
  and eax, F_VALORE											; toglie il flag di segno
  add ebp, [edi.cValCasa]								; somma il valore della casa destinazione
	add ebp, eax													; aggiorna il valore della posizione

  ;movq qword ptr [edx.mFlags], mm1			; salva il pezzo preso

  mov eax, [edx.mSpeciale]						  ; flags per mosse speciali (enpassant, arrocco, promozioni)
  mov [ebx.pCasa], edi                  ; aggiorna la posizione del pezzo mosso

  test eax, eax
  je em_ret

  cmp eax, F_SPINTADIDUE
  je em_spintadidue
  cmp eax, F_ARROCCO_00
  je em_arrocco_00
  cmp eax, F_ARROCCO_000
  je em_arrocco_000
  cmp eax, F_ENPASSANT
  je em_enpassant

em_promozione:
	mov [edi.cFlags], eax									; aggiorna i flags del pedone promosso
	add ebp, eax													; aggiorna il valore della posizione
  test eax, F_B_DONNA+F_N_DONNA
  je en_pnodonna
  mov ecx, offset MuoviDonna
  jmp em_setpromo
en_pnodonna:
  test eax, F_B_TORRE+F_N_TORRE
  je en_pnotorre
  mov ecx, offset MuoviTorre
  jmp em_setpromo
en_pnotorre:
  test eax, F_B_ALFIERE+F_N_ALFIERE
  je en_pnoalfiere
  mov ecx, offset MuoviAlfiere
  jmp em_setpromo
en_pnoalfiere:
  ;test eax, F_B_CAVALLO+F_N_CAVALLO
  ;jne en_pnocavallo
  mov ecx, offset MuoviCavallo
  ;jmp em_setpromo
em_setpromo:
  mov [ebx.pMuovi], ecx							  	; aggiorna la routine generazione mosse del pezzo
  jmp em_ret

em_arrocco_000:
	lea ecx, [edi+E]                      ; ecx = casa destinazione della torre
	lea ebx, [edi+WW]                     ; ebx = casa sorgente della torre
  jmp em_arrocco
em_arrocco_00:
	lea ecx, [edi+W]                      ; ecx = casa destinazione della torre
	lea ebx, [edi+E]	                    ; ebx = casa sorgente della torre
em_arrocco:
	mov eax, [ebx.cPezzo]									; punta alla torre nei pezzi
  movq mm0, [ebx]												; carica flags+pezzo
  movq [ebx], mm6												; salva casa vuota
  movq [ecx], mm0                       ; sposta la torre
  mov [eax.pCasa], ecx 									; aggiorna la posizione della torre
  add ebp, F_VAL_ARROCCO
  jmp em_ret

em_enpassant:
	mov [esi.nCasaEnP], edi								; casa della presa enpassant
em_aggiusta_enpassant:
	; eax: flags pedone preso
  ; ebx: pedone preso
  ; edi: casa destinazione fittizia (=casa del pedone preso)
  ; edx: mossa
  movq [edi], mm6												; pone a casa vuota la casa della presa laterale di pedone
  add edi, [esi.nDelta1]								; nuova casa di destinazione
  movq [edi], mm0                       ; sposta il pedone nella casa di presa enpassant
  mov [ebx.pCasa], edi                  ; aggiorna la posizione del pedone
  mov [esi.nmDst], edi                  ; aggiorna la casa di destinazione del pedone che prende nella mossa
  TESTPOINTER edi, scacchiera, badboard
  jmp em_ret

em_spintadidue:
	mov [esi.nEnPassant], edi  						; posizione pedone prendibile enpassant
  ;jmp em_ret

em_ret:
	if USA_ZOBRIST
    mov edi, [esi.nmPezzoP]             ; edi = pezzo preso
    test edi, edi
    je em_nopreso
    pxor mm5, [edi.pLastKey]            ; toglie key(preso, casa)
em_nopreso:
    mov edi, [edx.mPezzo]               ; edi = pezzo mosso
    mov ebx, [esi.nmSrc]                ; ebx = casa sorgente
    mov ecx, [esi.nmDst]                ; ecx = casa destinazione

		movq mm3, [edi.pKey]								; mm3 = key(pezzo)
		movq mm2, mm3												; mm2 = key(pezzo)

    pmullw mm3, QWORD PTR [ecx.cKey] 		; calcola la key(pezzo,casa dst)
    pmullw mm2, QWORD PTR [ebx.cKey] 		; calcola la key(pezzo,casa src)
    movq [edi.pLastKey], mm3						; salva la chiave attuale per eventuale cattura del pezzo

    pxor mm5, mm2                       ; toglie key(pezzo, casa src)
    pxor mm5, mm3                       ; aggiunge key(pezzo, casa dst)
  endif

	if DEBUG_ALFAGEMMA
	  call DebugCase
  endif
  if DEBUG_ASSERT
    call TestMossaOk
  endif
em_esci:
	TESTMOSSE
	ret
endp
;-------------------------------------------------------------------------------

AnnullaMossa proc
	; esi: nodo
	; edx: mossa da annullare
	; non deve modificare esi,ebx,edx

  if 0
	if DEBUG_ALFAGEMMA
  	ACAPO
  	ACAPO
	  PUTCHAR '-'
  	call DebugMossa
  endif
  endif

  if DEBUG_ASSERT
    call TestMossaOk
  endif

  mov ecx, [esi.nValIniziale]
  mov eax, [edx.mSpeciale]							; eax = flags mossa speciale
  mov ebp, ecx													; ripristina il valore della posizione
  mov ebx, [edx.mPezzo]									; ebx = pezzo mosso
	mov edi, [esi.nmDst]         					; edi = casa di destinazione
  TESTPOINTER edi, scacchiera, badboard

	mov ecx, [esi.nmSrc]         					; ecx = casa sorgente
  TESTPOINTER ecx, scacchiera, badboard

	movq mm0, qword ptr [edi]							; mm0 = flags + pezzo mosso
  movq mm1, qword ptr [esi.nmFlagsP]		; mm1 = flags + pezzo preso o casa vuota
  movq [ecx], mm0                       ; ripristina la casa sorgente
  movq [edi], mm1                       ; ripristina la casa destinazione

  if DEBUG_SIGLA
  	push eax
    mov eax, [esi.cFlags]
	  call TestSiglaPezzo
    pop eax
  endif

	mov [ebx.pCasa], ecx									; ripristina la casa del pezzo mosso
  dec [ebx.pNumMosse]										; numero di mosse eseguite dal pezzo
  TESTPOINTER ecx, scacchiera, badboard

	test eax, eax
  je am_ret
	cmp eax, F_ARROCCO_00
  je am_arrocco_00
	cmp eax, F_ARROCCO_000
  je am_arrocco_000
	cmp eax, F_ENPASSANT
  je am_enpassant
	cmp eax, F_SPINTADIDUE
  je am_spintadidue

am_promozione:
	mov eax, [esi.nmPedGen]								; routine generazione mosse pedone normale
	mov edi, [esi.nmPedFlags]							; flags del pedone normale
  mov [ebx.pMuovi], eax									; ripristina la routine generazione mosse del pedone
	mov [ecx.cFlags], edi									; ripristina i flags
	jmp am_ret

am_arrocco_000:													; edi = casa destinazione del Re (ora vuota)
	lea ecx, [edi+E]											; ecx = casa destinazione della torre
	lea ebx, [edi+WW]                     ; ebx = casa sorgente della torre
  jmp am_arrocco
am_arrocco_00:													; edi = casa destinazione del Re (ora vuota)
	lea ecx, [edi+W]											; ecx = casa destinazione della torre
	lea ebx, [edi+E]                      ; ebx = casa sorgente della torre
am_arrocco:
	mov eax, [ecx.cPezzo]									; eax punta alla torre nei pezzi
  movq mm0, [ecx]												; carica flags+pezzo della torre
  movq [ecx], mm6												; salva casa vuota
  movq [ebx], mm0                       ; ripristina la torre
  mov [eax.pCasa], ebx 									; ripristina la posizione della torre
  jmp am_ret

am_bad:
	call DebugVariante
	ret

am_enpassant:
	mov edi, [esi.nmDst]         					; edi = casa di destinazione reale
  TESTPOINTER edi, scacchiera, badboard
	mov ecx, edi
  sub ecx, [esi.nDelta1]                ; ecx = casa del pedone preso enpassant
  TESTPOINTER ecx, scacchiera, badboard

  movq mm0, [edi]												; carica il pedone preso (ripristinato nella casa finale del pedone mosso)
	movq [edi], mm6												; la casa era ovviamente vuota
  movq [ecx], mm0												; sposta indietro il pedone
  ;jmp am_ret
am_spintadidue:
	; il campo nEnPassant viene azzerato da EseguiMossa
am_ret:
	if USA_ZOBRIST
	  movq mm5, [esi.nKey]                  ; ripristina la zobrist key attuale
  endif
  
	if DEBUG_ALFAGEMMA
  	call DebugCase
  endif
	TESTMOSSE
	ret
endp
;-------------------------------------------------------------------------------
end


