global _ret_vals
global _nodi
;-------------------------------------------------------------------------------
global _perfect
global _alfagemma
global _getmosse
;-------------------------------------------------------------------------------
DEBUG           equ 0
DEBUG_PERFT     equ 0
DEBUG_PROGRESS  equ 0
DEBUG_VALRAMO   equ 0
DEBUG_MOSSE     equ 0

PERFECT	        equ 0
ITERATIVE       equ (1-PERFECT)
ITER_DELTA      equ 2
CONTA_MOSSE     equ 1
ACCONTENTATI    equ 0
ALFABETA_WINDOW equ 0
;-------------------------------------------------------------------------------
; casa:                                                          bit 31...0
; _______________ --------------- _______________ ---------------
; 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
; f e d c b a 9 8 7 6 5 4 3 2 1 0 f e d c b a 9 8 7 6 5 4 3 2 1 0
; | |           | |             | |             | | | | | | | | |
; | |           | |             | |             | | | | | | | | \__ re
; | |           | |             | |             | | | | | | | \____ donna
; | |           | |             | |             | | | | | | \______ torre
; | | val pezzo | |  val casa   | |   sigla     | | | | | \________ alfiere
; | |           | |             | |   pezzo     | | | | \__________ cavallo
; | |           | |             | |             | | | \____________ pedone
; | |           | |             | |             | | \______________ nero
; | |           | |             | |             | \________________ bianco
; | |           | |             | \_____________\__________________ sigla del pezzo (B:pcadr N:PCADR
; | |           | \_____________\__________________________________ valore della casa
; | \___________\__________________________________________________ valore del pezzo
; \________________________________________________________________ casa vuota
;                                   ___
; and bit colore      z: preso pezzo   \___legale
;                     s: vuota      ___/
;                     g: illegale
;-------------------------------------------------------------------------------
BIT_FLAGS        equ       1h 					; 1 byte
BIT_SIGLA        equ     100h 					; 2 byte
BIT_VALCASA      equ   10000h 					; 3 byte
BIT_VALPEZZO     equ 1000000h 					; 4 byte
BIT_PEZZO2       equ       8  					; 2 byte
;-------------------------------------------------------------------------------
F_RE             equ 00000001b 					; il bit 0 non cambia anche negando il valore
F_DONNA          equ 00000010b 					; in questo modo, segnala lo scacco e non viene
F_TORRE          equ 00000100b 					; modificato, cambiando livello
F_ALFIERE        equ 00001000b
F_CAVALLO        equ 00010000b
F_PEDONE         equ 00100000b
F_NERO           equ 01000000b
F_BIANCO         equ 10000000b
;-------------------------------------------------------------------------------
FEN_RE_N       	 equ 'k'
FEN_DONNA_N      equ 'q'
FEN_TORRE_N      equ 'r'
FEN_ALFIERE_N    equ 'b'
FEN_CAVALLO_N    equ 'n'
FEN_PEDONE_N     equ 'p'
;-------------------------------------------------------------------------------
FEN_RE_B         equ 'K'
FEN_DONNA_B      equ 'Q'
FEN_TORRE_B      equ 'R'
FEN_ALFIERE_B    equ 'B'
FEN_CAVALLO_B    equ 'N'
FEN_PEDONE_B     equ 'P'
;-------------------------------------------------------------------------------
VUOTA            equ 80000000h
ILLEG            equ (F_BIANCO + F_NERO)
MINIMO           equ 80000000h
MASSIMO          equ 7ffffffeh
;-------------------------------------------------------------------------------
F_VAL_RE         equ 01000000b
F_VAL_DONNA      equ 00001010b
F_VAL_TORRE      equ 00000101b
F_VAL_ALFIERE    equ 00000011b
F_VAL_CAVALLO    equ 00000011b
F_VAL_PEDONE     equ 00000001b
;-------------------------------------------------------------------------------
F_VAL_VUOTA      equ 00000000b
F_VAL_MATTO      equ (F_RE               +BIT_VALPEZZO*F_VAL_RE)
F_DELTA_MATTO    equ BIT_VALCASA
;-------------------------------------------------------------------------------
F_RE_BIANCO      equ (F_BIANCO+F_RE      +(BIT_SIGLA*FEN_RE_B     ) +(BIT_VALPEZZO*F_VAL_RE))
F_DONNA_BIANCA   equ (F_BIANCO+F_DONNA   +(BIT_SIGLA*FEN_DONNA_B  ) +(BIT_VALPEZZO*F_VAL_DONNA))
F_TORRE_BIANCA   equ (F_BIANCO+F_TORRE   +(BIT_SIGLA*FEN_TORRE_B  ) +(BIT_VALPEZZO*F_VAL_TORRE))
F_ALFIERE_BIANCO equ (F_BIANCO+F_ALFIERE +(BIT_SIGLA*FEN_ALFIERE_B) +(BIT_VALPEZZO*F_VAL_ALFIERE))
F_CAVALLO_BIANCO equ (F_BIANCO+F_CAVALLO +(BIT_SIGLA*FEN_CAVALLO_B) +(BIT_VALPEZZO*F_VAL_CAVALLO))
F_PEDONE_BIANCO  equ (F_BIANCO+F_PEDONE  +(BIT_SIGLA*FEN_PEDONE_B ) +(BIT_VALPEZZO*F_VAL_PEDONE))
;-------------------------------------------------------------------------------
F_RE_NERO        equ (F_NERO+F_RE        +(BIT_SIGLA*FEN_RE_N     ) +(BIT_VALPEZZO*F_VAL_RE     ))
F_DONNA_NERA     equ (F_NERO+F_DONNA     +(BIT_SIGLA*FEN_DONNA_N  ) +(BIT_VALPEZZO*F_VAL_DONNA  ))
F_TORRE_NERA     equ (F_NERO+F_TORRE     +(BIT_SIGLA*FEN_TORRE_N  ) +(BIT_VALPEZZO*F_VAL_TORRE  ))
F_ALFIERE_NERO   equ (F_NERO+F_ALFIERE   +(BIT_SIGLA*FEN_ALFIERE_N) +(BIT_VALPEZZO*F_VAL_ALFIERE))
F_CAVALLO_NERO   equ (F_NERO+F_CAVALLO   +(BIT_SIGLA*FEN_CAVALLO_N) +(BIT_VALPEZZO*F_VAL_CAVALLO))
F_PEDONE_NERO    equ (F_NERO+F_PEDONE    +(BIT_SIGLA*FEN_PEDONE_N ) +(BIT_VALPEZZO*F_VAL_PEDONE ))
;-------------------------------------------------------------------------------
F_VUOTA          equ VUOTA  ; (0-BIT_VALCASA)
F_ILLEGALE       equ ILLEG              
;-------------------------------------------------------------------------------
PROMO_DONNA			 equ 4
PROMO_TORRE			 equ 3
PROMO_ALFIERE		 equ 2
PROMO_CAVALLO		 equ 1
;-------------------------------------------------------------------------------
RetVals struc
	rValore        dd ?
	rValPedone     dd ?
	rMossa         dd ?
	rNumMosse      dd ?
	rNumNodi       dd ?
	rLivello       dd ? 									; livello massimo da analizzare
	rLivAttuale    dd ? 									; livello in esame per iterative deepening
	rClockL        dd ?
	rClockH        dd ?
ends
;-------------------------------------------------------------------------------
; NB:
Casa struc
	cFlags dd ?  													; flags del pezzo
	cPezzo dd ?  													; punta al pezzo in pezzi[]
ends
SIZECASA2 equ 3
;-------------------------------------------------------------------------------
Mossa struc
	mValore    	dd ?    									; valore per ricerca
	mValRamo    dd ?    									; valore reale della mossa
	mPezzo     	dd ?    									; pezzo che esegue la mossa
	mDelta     	dd ?    									; spostamento del pezzo
	mFlags     	dd ?    									; flags pezzo preso
	mPreso     	dd ?    									; pezzo preso
	mDst       	dd ?    									; casa di destinazione
	mSrc       	dd ?    									; casa sorgente
  mPromoFlags dd ?											; mossa da eseguire: flags a cui il pedone  stato promosso / mossa eseguita: flags precedenti del pedone
  mPromoGen   dd ?                      ; mossa da eseguire: ruotine di generazione mosse del pedone promosso / mossa eseguita: routine precedente
  mTorre      dd ?                      ; torre coinvolta nell'eventuale arrocco
  mSrcTorre   dd ?                      ; casa iniziale della torre nell'arrocco
  mDstTorre   dd ?                      ; casa finale della torre nell'arrocco
  mFree3      dd ?                      ; libero
  mFree2      dd ?                      ; libero
  mFree1      dd ?                      ; libero
ends
SIZEMOSSA2 equ 6 												; log2(size Mossa)
;-------------------------------------------------------------------------------
Pezzo struc
	pCasa        dd ?  										; casa in cui si trova il pezzo
	pMuovi       dd ?  										; funzione di generazione delle mosse
  pNumMosse    dd ?                     ; numero di mosse eseguite per il pezzo
  pSigla       dd ?                     ; usato solo per debug
ends
SIZEPEZZO2 equ 4 												; log2(size Pezzo)
;-------------------------------------------------------------------------------
Nodo struc
	nFlags      dd ?   										; flags del colore che deve muovere
	nMigliore   dd ?   										; migliore mossa del nodo
	nValRamo    dd ?   										; valore del ramo
	nPezzi      dd ?   										; punta a pezzi_bianchi o pezzi_neri, a seconda del colore del nodo
	nMosse      dd ?   										; punta alla prima mossa del nodo
	nEseguita   dd ?   										; ultima mossa eseguita nel nodo
	nIterazione dd ?   										; >0 se non  la prima iterazione
	nLivello    dd ?   										; livello di profondit (ply)
	nValMatto   dd ?   										; valore del matto (decrescente per livello)
	nEnPassant  dd ?   										; casa del pedone prendibile en-passant
	nCasaEnP  	dd ?   										; casa della presa en passant
	nDelta1     dd ?   										; offset per spinta di uno di pedone
	nDelta2     dd ?   										; offset per spinta di due di pedone
	nRe         dd ?   										; punta al RE
	nNumMosse		dd ?   										; numero mosse del livello (per perft)
	nNumValide  dd ?   										; numero mosse eseguite valide (se 0 => stallo o matto)
ends
SIZENODO2 equ 6 												; log2(size Nodo)
;-------------------------------------------------------------------------------
V equ VUOTA,0
I equ ILLEG,0
B equ BIT_VALCASA

					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
scacchiera dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
promoB     dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
m2pedoneN  dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
					 dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
					 dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
					 dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
m2pedoneB	 dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
promoN		 dd V,V,V,V,V,V,V,V,I,I,I,I,I,I,I,I
					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
					 dd I,I,I,I,I,I,I,I,I,I,I,I,I,I,I,I
;-------------------------------------------------------------------------------
MAXNODI  equ 64
MAXMOSSE equ (MAXNODI*128)
;-------------------------------------------------------------------------------
S    equ (16*size Casa)
N    equ (-S)
N_N  equ (N+N)
S_S  equ (S+S)
E    equ (size Casa)
EE   equ (E+E)
EEE  equ (E+E+E)
W    equ (0-E)
WW   equ (W+W)
WWW equ  (W+W+W)
WWWW equ (W+W+W+W)
NE   equ (N+E)
NW   equ (N+W)
SE   equ (S+E)
SW   equ (S+W)
NNE  equ (N+N+E)
NNW  equ (N+N+W)
SSE  equ (S+S+E)
SSW  equ (S+S+W)
NEE  equ (N+E+E)
NWW  equ (N+W+W)
SEE  equ (S+E+E)
SWW  equ (S+W+W)

CASERIGA  equ 16
SIZERIGA2 equ (4+SIZECASA2)							; log2(S)


