timeb struc
      time dd ?
      millitm dw ?
      timezone dw ?
      dstflag dw
ends
;-------------------------------------------------------------------------------
RetVals struc
	rValore         dd ?
	rValPedone      dd ?

	rNumMosseL      dd ?                  ; numero mosse legali eseguite
	rNumMosseH      dd ?                  ; numero mosse legali eseguite

	rNumNodiL       dd ?
	rNumNodiH       dd ?

	rClockL         dd ?
	rClockH         dd ?

	rNumMossa       dd ?									; numero di mossa per debug
	rLivello        dd ? 									; numero livello massimo da analizzare

  rLivelloP       dd ?                  ; indirizzo ultimo nodo
	rLivAttuale     dd ? 									; livello in esame per iterative deepening

	rValPos         dd ?                  ; valore progressivo posizione
  rTTable					dd ?									; puntatore alla transposition table (allocata dalla parte C++)
  rTTableSize			dd ?									; dimensione della " "
  rTTableMask			dd ?									; maschera per hashing indice transposition table

	rNumTTL         dd ?                  ; numero di posizioni trovate nella TT (parte bassa)
	rNumTTH         dd ?                  ; numero di posizioni trovate nella TT (parte alta)

  rFlags          dd ?                  ; flags: RT_CLEAR_TT
	rPosizione      dd ?                  ; punta alla posizione iniziale in formato FEN
	rPosizioneAtt   dd ?                  ; punta alla posizione attuale in formato FEN
	rMossa          dd ?                  ; punta alla mossa da eseguire
  rMaxTime        dd ?									; tempo massimo in ms per ogni mossa
  rFullTime       dd ?									; tempo massimo in ms per tutta la partita
  rMosseGiocate   dd ?									; numero di mosse giocate
  rStop           dd ?									; ferma la ricerca se <> 0
  rTimeInizio     timeb ?
  rTimeFine       timeb ?
ends
RT_CLEAR_TT = 1
;-------------------------------------------------------------------------------
Casa struc
	cFlags   dd ?  												; flags del pezzo
	cPezzo   dd ?  												; indirizzo del pezzo in pezzi[]
  cKey     DQ ?													; Zobrist key della casa
	cValCasa dd ?  												; valore della casa
	cFree3   dd ?  												; libero
	cFree2   dd ?  												; libero
	cFree1   dd ?  												; libero
ends
SIZECASA2 equ 5
;-------------------------------------------------------------------------------
Mossa struc
  ;---------------mmx
	mValore    	dd ?    									; valore per ricerca
	mPezzoPreso	dd ?    									; pezzo preso
  ;---------------mmx
  ; mqSpeciale label dq
  mSpeciale   dd ?											; flags mossa speciale
  mSrc        dd ?                      ; casa sorgente (solo per debug)
  ;---------------
	mPezzo     	dd ?    									; pezzo che esegue la mossa
	mDelta     	dd ?    									; spostamento del pezzo
  ;---------------
	mValRamo    dd ?    									; valore reale della mossa
	mNumMossa  	dd ?    									; debug: numero mossa
ends
SIZEMOSSA2 equ 5 												; log2(size Mossa)
;-------------------------------------------------------------------------------
Pezzo struc
	pCasa        dd ?  										; casa in cui si trova il pezzo
	pMuovi       dd ?  										; funzione di generazione delle mosse
  pNumMosse    dd ?                     ; numero di mosse eseguite per il pezzo
  pSigla       dd ?                     ; usato solo per debug
  pKey  			 DQ ?											; Zobrist key del pezzo
  pLastKey		 DQ ?											; Zobrist key della casa attuale (da togliere se preso pezzo)
ends
SIZEPEZZO2 equ 5 												; log2(size Pezzo)
;-------------------------------------------------------------------------------
Nodo struc
	nFlags       dd ?  										; flags del colore che deve muovere
	nMigliore    dd ?  										; migliore mossa del nodo
	nValRamo     dd ?  										; valore del ramo
	nPezzi       dd ?  										; punta a pezzi_bianchi o pezzi_neri, a seconda del colore del nodo
	nMosse       dd ?  										; punta alla prima mossa del nodo
	nLivello     dd ?  										; livello di profondit (ply)
	nValIniziale dd ?											; valore iniziale del nodo
	nRe          dd ?  										; punta al RE
  ;----------------mmx
	nEnPassant   dd ?  										; casa del pedone prendibile en-passant
	nCasaEnP  	 dd ?  										; casa della presa en passant
  ;----------------mmx
	nDelta1      dd ?  										; offset per spinta di uno di pedone
	nDelta2      dd ?  										; offset per spinta di due di pedone
  ;----------------
	nNumMosseL	 dd ?  										; numero mosse del livello (per perft)
	nNumMosseH	 dd ?  										; numero mosse del livello (per perft)
	nNumValideL  dd ?  										; numero mosse eseguite valide (se 0 => stallo o matto)
	nNumValideH  dd ?  										; numero mosse eseguite valide (se 0 => stallo o matto)
  nEseAnn      dd ?											; numero di esegui/annulla per il nodo (deve restare a zero)
	nEseguita    dd ?  										; ultima mossa eseguita nel nodo
  ;-------------------------------------; dati dell'ultima mossa eseguita (per annullarla velocemente)
	nmDst        dd ?    									; casa di destinazione
	nmSrc        dd ?    									; casa sorgente
  ;----------------mmx
  nmPedFlags   dd ?											; flags iniziali dei pedoni del colore del nodo
  nmPedGen     dd ?                     ; routine generazione precedente del pedone promosso
  ;----------------
  nmFlagsP		 dd ?											; flags pezzo preso
  nmPezzoP 		 dd ?											; pezzo preso
  ;----------------
  nKey         DQ ?                     ; Zobrist key della posizione prima delle mosse
  nRand        DQ ?                     ; chiave del colore che muove
  nHashIndex   dd ?											; indice alla ttable della posizione dopo l'ultima mossa eseguita
  nMigliorePrev dd ?                    ; miglior mossa iterazione precedente
  nFree0e      dd ?
  nFree0f      dd ?
ends
SIZENODO2 equ 7 												; log2(size Nodo)
;-------------------------------------------------------------------------------
Hash struc
	hKey				 DQ ?                     ; Zobrist key
  hValue       dd                       ; valore della posizione
  hType        dw                       ; tipo <0 alfa, >0 beta, =0 valore ramo
  hPly         dw                       ; profondit
ends
SIZEHASH2 equ 4
;-------------------------------------------------------------------------------

